package self_disclosure_plugin

test_users_self_info {
	users_self_info == true with input.sub as "A" with input.user_id as "A" with input.user_roles as ["student"]
	users_self_info == true with input.sub as "A" with input.user_id as "A" with input.user_roles as ["teacher"]
	users_self_info == false with input.sub as "A" with input.user_id as "B" with input.user_roles as ["student"]
	users_self_info == false with input.sub as "A" with input.user_id as "" with input.user_roles as ["student"]
	users_self_info == false with input.sub as "" with input.user_id as "B" with input.user_roles as ["student"]
	users_self_info == false with input.sub as "" with input.user_id as "" with input.user_roles as ["student"]
	users_self_info == false with input.sub as "A" with input.user_id as "A" with input.user_roles as ["school_admin"]
	users_self_info == false with input.sub as "A" with input.user_id as "A" with input.user_roles as ["staff"]
	users_self_info == false with input.sub as "A" with input.user_id as "A" with input.user_roles as ["other"]
	users_self_info == false with input.sub as "" with input.user_id as "" with input.user_roles as ["school_admin"]
	users_self_info == false
}

user1 := {
	"name": "user1",
	"ucsschool_roles": ["school_admin:school:School1"],
}

user2 := {
	"name": "user2",
	"ucsschool_roles": ["school_admin:school:School2"],
}

user3 := {
	"name": "user3",
	"ucsschool_roles": ["teacher:school:School1"],
}

group1 := {
	"ucsschool_roles": ["school_class:school:School1"],
	"users": ["user0", "user1", "user3"],
}

group2 := {
	"ucsschool_roles": ["workgroup:school:School1"],
	"users": ["user0", "user1"],
}

group3 := {
	"ucsschool_roles": ["workgroup:school:School1"],
	"users": ["user0", "user2"],
}

group4 := {
	"ucsschool_roles": ["workgroup:school:School2"],
	"users": ["user0", "user2", "user3"],
}

test_groups_members {
	groups_members == false with input.user as user1 with input.group as group1 # school_admin accesses member school_class in school
	groups_members == false with input.user as user1 with input.group as group2 # school_admin accesses member workgroup in school
	groups_members == false with input.user as user1 with input.group as group3 # school_admin accesses workgroup in school
	groups_members == false with input.user as user2 with input.group as group1 # school_admin accesses group from other school
	groups_members == true with input.user as user3 with input.group as group1 # teacher accesses member group in school
	groups_members == false with input.user as user3 with input.group as group2 # teacher accesses group in same school but not member
	groups_members == false with input.user as user3 with input.group as group4 # teacher accesses member group in other school
	groups_members == false
}
